var gameProperties = {
    screenWidth: 640,
    screenHeight: 480,

    tileWidth: 32,
    tileHeight: 32,

    boardWidth: 9,
    boardHeight: 9,

    totalMines: 10
};

var states = {
    game: 'game'
};

var graphicAssets = {
    tiles: {URL: 'assets/tiles.png', name: 'tiles', frames: 14}
};

var fontStyles = {
    counterFontStyle: {font: '20px Arial', fill: '#FFFFFF'}
};

var gameState = function(game) {
    this.boardTop;
    this.boardLeft;
    this.board;
    this.timer;
};

gameState.prototype = {

    init: function() {
        var boardHeight = gameProperties.tileHeight * gameProperties.boardHeight;
        this.boardTop = (gameProperties.screenHeight - (boardHeight)) * 0.5;
        var boardWidth = gameProperties.tileWidth * gameProperties.boardWidth;
        this.boardLeft = (gameProperties.screenWidth - (boardWidth)) * 0.5;
    },

    preload: function() {
        game.load.spritesheet
        (
            graphicAssets.tiles.name,
            graphicAssets.tiles.URL,
            gameProperties.tileWidth,
            gameProperties.tileHeight,
            graphicAssets.tiles.frames
        );
        game.canvas.oncontextmenu = function(e) {
            e.preventDefault();
        };
    },

    create: function() {
        this.initBoard();
        this.initUI();
    },

    update: function() {

    },

    initBoard: function() {
        this.board = new Board
        (
            gameProperties.boardWidth,
            gameProperties.boardHeight,
            gameProperties.totalMines
        );
        this.board.moveTo(this.boardLeft, this.boardTop);
        this.board.onTileClicked.addOnce(this.startGame, this);
        this.board.onEndGame.addOnce(this.endGame, this);
    },

    initUI: function() {
        var top = this.boardTop - 20;
        var left = this.boardLeft;

        this.timer = new Timer(left, top);
    },

    startGame: function() {
        this.timer.start();
    },

    endGame: function() {
        this.timer.stop();
    }
};

var game = new Phaser.Game
(
    gameProperties.screenWidth,
    gameProperties.screenHeight,
    Phaser.AUTO,
    'wrapper'
);
game.state.add(states.game, gameState);
game.state.start(states.game);